<template>
    <section class="section">
        <h1 class="title">{{ titleForm }}</h1>
        <b-form @reset="onReset" method="post" @submit.prevent="submit">
            <b-form-group id="input-group-1" label="Titre" label-for="input-1">
                <b-form-input id="input-1" v-model="form.title" type="text" placeholder="Titre de l'idée" required>
                </b-form-input>
            </b-form-group>

            <b-form-group id="input-group-2" label="Description" label-for="input-2">
                <b-form-textarea id="textarea" v-model="form.description" placeholder="Description de l'idée" rows="3"
                    max-rows="6">
                </b-form-textarea>
            </b-form-group>
            <Notification :messages="error" v-if="error" />

            <div id="group-btn-register">
                <b-button type="submit" variant="outline-secondary">{{ labelSubmit }}
                </b-button>
                <b-button type="reset" variant="outline-secondary">Annuler
                </b-button>
            </div>

        </b-form>
    </section>
</template>

<script>
import Notification from '../components/Notification.vue';


export default {
    components: {
        Notification,
    },
    created() {
        if (this.$route.params.idea) {
            const { title, description, _id } = this.$route.params.idea;
            this.$data.form.title = title;
            this.$data.form.description = description;
            this.$data.id = _id;
            this.$data.titleForm = `Modification de l'idée ${_id}`;
            this.$data.labelSubmit = "Mettre à jour";

        }
    },
    data: function () {
        return {
            form: {
                title: "",
                description: ""
            },
            error: null,
            titleForm: "Création d'une idée",
            id: null,
            labelSubmit: "Créer"
        }
    },
    methods: {
        async submit() {
            this.error = null;
            const { form: { title, description }, id } = this;
            try {
                const path = (id) ? `idea/${id}` : 'idea';
                const method = (id) ? 'put' : 'post';
                await this.$axios[method](path, {
                    title,
                    description
                });
                this.$router.push('/')

            } catch (e) {
                const errors = Object.values(e.response.data);
                this.error = errors.flat();
            }
        },
        onReset(event) {
            event.preventDefault()

            this.error = null;
            if (this.id) {
                const { title, description } = this.$route.params.idea;
                this.form.title = title;
                this.form.description = description;
            } else {
                this.form.title = ''
                this.form.description = ''
            }
        }
    }
}
</script>
